import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import greenfoot.junitUtils.runner.GreenfootRunner;

import greenfoot.World;
import greenfoot.junitUtils.WorldCreator;

/**
 * Test Driven Development (TDD)
 * 
 * @author Francisco Guerra
 */
@RunWith(GreenfootRunner.class)
public class WormTest {

    Worm worm;
    
    @Before
    public void setUp() throws Exception {
        // GIVEN a worm into any world
        World world = WorldCreator.getWorld(560, 560, 1);
        worm = new Worm();
        world.addObject(worm, 100, 200);
    }

    @Test
    public void testNoMove() throws Exception {
        // GIVEN the initial position of the worm
        int x = worm.getX();
        int y = worm.getY();
        
        for (int k=0; k<20; k++) {
            // WHEN time goes by
            worm.act();
            
            // THEN the worm is still in the same place
            assertEquals(x, worm.getX());
            assertEquals(y, worm.getY());
        }
    }

    @Test
    public void testNoMoveBis() throws Exception {
        // GIVEN the initial position of the worm
        CrabWorld crabWorld = new CrabWorld();
        assertTrue(crabWorld.getObjects(Worm.class).size() > 0);
        Worm worm = crabWorld.getObjects(Worm.class).get(0);
        int x = worm.getX();
        int y = worm.getY();
        
        for (int k=0; k<20; k++) {
            // WHEN time goes by
            worm.act();
            
            // THEN the worm is still in the same place
            assertEquals(x, worm.getX());
            assertEquals(y, worm.getY());
        }
    }

}
